rapidjson::GenericDocument< Encoding, Allocator, StackAllocator > Class Template Reference

A document for parsing JSON text as DOM. More...

`#include <document.h>`

Inheritance diagram for rapidjson::GenericDocument< Encoding, Allocator, StackAllocator >:

## Public Types

typedef Encoding::Ch | Ch
| Character type derived from Encoding.
typedef GenericValue< Encoding, Allocator > | ValueType
| Value type of the document.
typedef Allocator | AllocatorType
| Allocator type from template parameter.
Public Types inherited from rapidjson::GenericValue< Encoding, Allocator >
typedef GenericMember< Encoding, Allocator > | Member
| Name-value pair in an object.
typedef Encoding | EncodingType
| Encoding type from template parameter.
typedef Allocator | AllocatorType
| Allocator type from template parameter.
typedef Encoding::Ch | Ch
| Character type derived from Encoding.
typedef GenericStringRef< Ch > | StringRefType
| Reference to a constant string.
typedef GenericMemberIterator< false, Encoding, Allocator >::Iterator | MemberIterator
| Member iterator for iterating in object.
typedef GenericMemberIterator< true, Encoding, Allocator >::Iterator | ConstMemberIterator
| Constant member iterator for iterating in object.
typedef GenericValue * | ValueIterator
| Value iterator for iterating in array.
typedef const GenericValue * | ConstValueIterator
| Constant value iterator for iterating in array.
typedef GenericValue< Encoding, Allocator > | ValueType
| Value type of itself.
typedef GenericArray< false, ValueType > | Array
typedef GenericArray< true, ValueType > | ConstArray
typedef GenericObject< false, ValueType > | Object
typedef GenericObject< true, ValueType > | ConstObject

## Public Member Functions

| GenericDocument (Type type, Allocator *allocator=0, size_t stackCapacity=kDefaultStackCapacity, StackAllocator *stackAllocator=0)
| Constructor. More...
| GenericDocument (Allocator *allocator=0, size_t stackCapacity=kDefaultStackCapacity, StackAllocator *stackAllocator=0)
| Constructor. More...
GenericDocument & | Swap (GenericDocument &rhs) RAPIDJSON_NOEXCEPT
| Exchange the contents of this document with those of another. More...
template<typename Generator >
GenericDocument & | Populate (Generator &g)
| Populate this document by a generator which produces SAX events. More...
Allocator & | GetAllocator ()
| Get the allocator of this document.
size_t | GetStackCapacity () const
| Get the capacity of stack in bytes.
bool | Null ()
bool | Bool (bool b)
bool | Int (int i)
bool | Uint (unsigned i)
bool | Int64 (int64_t i)
bool | Uint64 (uint64_t i)
bool | Double (double d)
bool | RawNumber (const Ch *str, SizeType length, bool copy)
bool | String (const Ch *str, SizeType length, bool copy)
bool | StartObject ()
bool | Key (const Ch *str, SizeType length, bool copy)
bool | EndObject (SizeType memberCount)
bool | StartArray ()
bool | EndArray (SizeType elementCount)
Parse from stream
template<unsigned parseFlags, typename SourceEncoding , typename InputStream >
GenericDocument & | ParseStream (InputStream &is)
| Parse JSON text from an input stream (with Encoding conversion) More...
template<unsigned parseFlags, typename InputStream >
GenericDocument & | ParseStream (InputStream &is)
| Parse JSON text from an input stream. More...
template<typename InputStream >
GenericDocument & | ParseStream (InputStream &is)
| Parse JSON text from an input stream (with kParseDefaultFlags) More...
Parse in-place from mutable string
template<unsigned parseFlags>
GenericDocument & | ParseInsitu (Ch *str)
| Parse JSON text from a mutable string. More...
GenericDocument & | ParseInsitu (Ch *str)
| Parse JSON text from a mutable string (with kParseDefaultFlags) More...
Parse from read-only string
template<unsigned parseFlags, typename SourceEncoding >
GenericDocument & | Parse (const typename SourceEncoding::Ch *str)
| Parse JSON text from a read-only string (with Encoding conversion) More...
template<unsigned parseFlags>
GenericDocument & | Parse (const Ch *str)
| Parse JSON text from a read-only string. More...
GenericDocument & | Parse (const Ch *str)
| Parse JSON text from a read-only string (with kParseDefaultFlags) More...
template<unsigned parseFlags, typename SourceEncoding >
GenericDocument & | Parse (const typename SourceEncoding::Ch *str, size_t length)
template<unsigned parseFlags>
GenericDocument & | Parse (const Ch *str, size_t length)
GenericDocument & | Parse (const Ch *str, size_t length)
template<unsigned parseFlags, typename SourceEncoding >
GenericDocument & | Parse (const std::basic_string< typename SourceEncoding::Ch > &str)
template<unsigned parseFlags>
GenericDocument & | Parse (const std::basic_string< Ch > &str)
GenericDocument & | Parse (const std::basic_string< Ch > &str)
Handling parse errors
bool | HasParseError () const
| Whether a parse error has occured in the last parsing.
ParseErrorCode | GetParseError () const
| Get the ParseErrorCode of last parsing.
size_t | GetErrorOffset () const
| Get the position of last parsing error in input, 0 otherwise.
| operator ParseResult () const
| Implicit conversion to get the last parse result. More...
Public Member Functions inherited from rapidjson::GenericValue< Encoding, Allocator >
template<typename Handler >
bool | Accept (Handler &handler) const
| Generate events of this value to a Handler. More...
Type | GetType () const
bool | IsNull () const
bool | IsFalse () const
bool | IsTrue () const
bool | IsBool () const
bool | IsObject () const
bool | IsArray () const
bool | IsNumber () const
bool | IsInt () const
bool | IsUint () const
bool | IsInt64 () const
bool | IsUint64 () const
bool | IsDouble () const
bool | IsString () const
bool | IsLosslessDouble () const
bool | IsFloat () const
bool | IsLosslessFloat () const
GenericValue & | SetNull ()
bool | GetBool () const
| Set boolean value.
GenericValue & | SetBool (bool b)
GenericValue & | SetObject ()
| Set this value as an empty object. More...
SizeType | MemberCount () const
| Get the number of members in the object.
bool | ObjectEmpty () const
| Check whether the object is empty.
template<typename T >
GenericValue & | operator[] (T *name)
| Get a value from an object associated with the name. More...
template<typename T >
const GenericValue & | operator[] (T *name) const
template<typename SourceAllocator >
GenericValue & | operator[] (const GenericValue< Encoding, SourceAllocator > &name)
| Get a value from an object associated with the name. More...
template<typename SourceAllocator >
const GenericValue & | operator[] (const GenericValue< Encoding, SourceAllocator > &name) const
GenericValue & | operator[] (const std::basic_string< Ch > &name)
| Get a value from an object associated with name (string object).
const GenericValue & | operator[] (const std::basic_string< Ch > &name) const
ConstMemberIterator | MemberBegin () const
| Const member iterator. More...
ConstMemberIterator | MemberEnd () const
| Const past-the-end member iterator. More...
MemberIterator | MemberBegin ()
| Member iterator. More...
MemberIterator | MemberEnd ()
| Past-the-end member iterator More...
bool | HasMember (const Ch *name) const
| Check whether a member exists in the object. More...
bool | HasMember (const std::basic_string< Ch > &name) const
| Check whether a member exists in the object with string object. More...
template<typename SourceAllocator >
bool | HasMember (const GenericValue< Encoding, SourceAllocator > &name) const
| Check whether a member exists in the object with GenericValue name. More...
MemberIterator | FindMember (const Ch *name)
| Find member by name. More...
ConstMemberIterator | FindMember (const Ch *name) const
template<typename SourceAllocator >
MemberIterator | FindMember (const GenericValue< Encoding, SourceAllocator > &name)
| Find member by name. More...
template<typename SourceAllocator >
ConstMemberIterator | FindMember (const GenericValue< Encoding, SourceAllocator > &name) const
MemberIterator | FindMember (const std::basic_string< Ch > &name)
| Find member by string object name. More...
ConstMemberIterator | FindMember (const std::basic_string< Ch > &name) const
GenericValue & | AddMember (GenericValue &name, GenericValue &value, Allocator &allocator)
| Add a member (name-value pair) to the object. More...
GenericValue & | AddMember (GenericValue &name, StringRefType value, Allocator &allocator)
| Add a constant string value as member (name-value pair) to the object. More...
GenericValue & | AddMember (GenericValue &name, std::basic_string< Ch > &value, Allocator &allocator)
| Add a string object as member (name-value pair) to the object. More...
template<typename T >
GenericValue & | AddMember (GenericValue &name, T value, Allocator &allocator)
| Add any primitive value as member (name-value pair) to the object. More...
GenericValue & | AddMember (StringRefType name, GenericValue &value, Allocator &allocator)
| Add a member (name-value pair) to the object. More...
GenericValue & | AddMember (StringRefType name, StringRefType value, Allocator &allocator)
| Add a constant string value as member (name-value pair) to the object. More...
template<typename T >
GenericValue & | AddMember (StringRefType name, T value, Allocator &allocator)
| Add any primitive value as member (name-value pair) to the object. More...
void | RemoveAllMembers ()
| Remove all members in the object. More...
bool | RemoveMember (const Ch *name)
| Remove a member in object by its name. More...
bool | RemoveMember (const std::basic_string< Ch > &name)
template<typename SourceAllocator >
bool | RemoveMember (const GenericValue< Encoding, SourceAllocator > &name)
MemberIterator | RemoveMember (MemberIterator m)
| Remove a member in object by iterator. More...
MemberIterator | EraseMember (ConstMemberIterator pos)
| Remove a member from an object by iterator. More...
MemberIterator | EraseMember (ConstMemberIterator first, ConstMemberIterator last)
| Remove members in the range [first, last) from an object. More...
bool | EraseMember (const Ch *name)
| Erase a member in object by its name. More...
bool | EraseMember (const std::basic_string< Ch > &name)
template<typename SourceAllocator >
bool | EraseMember (const GenericValue< Encoding, SourceAllocator > &name)
Object | GetObject ()
ConstObject | GetObject () const
GenericValue & | SetArray ()
| Set this value as an empty array. More...
SizeType | Size () const
| Get the number of elements in array.
SizeType | Capacity () const
| Get the capacity of array.
bool | Empty () const
| Check whether the array is empty.
void | Clear ()
| Remove all elements in the array. More...
GenericValue & | operator[] (SizeType index)
| Get an element from array by index. More...
const GenericValue & | operator[] (SizeType index) const
ValueIterator | Begin ()
| Element iterator. More...
ValueIterator | End ()
| Past-the-end element iterator More...
ConstValueIterator | Begin () const
| Constant element iterator. More...
ConstValueIterator | End () const
| Constant past-the-end element iterator. More...
GenericValue & | Reserve (SizeType newCapacity, Allocator &allocator)
| Request the array to have enough capacity to store elements. More...
GenericValue & | PushBack (GenericValue &value, Allocator &allocator)
| Append a GenericValue at the end of the array. More...
GenericValue & | PushBack (StringRefType value, Allocator &allocator)
| Append a constant string reference at the end of the array. More...
template<typename T >
GenericValue & | PushBack (T value, Allocator &allocator)
| Append a primitive value at the end of the array. More...
GenericValue & | PopBack ()
| Remove the last element in the array. More...
ValueIterator | Erase (ConstValueIterator pos)
| Remove an element of array by iterator. More...
ValueIterator | Erase (ConstValueIterator first, ConstValueIterator last)
| Remove elements in the range [first, last) of the array. More...
Array | GetArray ()
ConstArray | GetArray () const
template<typename T >
bool | Is () const
| Templated version for checking whether this value is type T. More...
template<typename T >
T | Get () const
template<typename T >
T | Get ()
template<typename T >
ValueType & | Set (const T &data)
template<typename T >
ValueType & | Set (const T &data, AllocatorType &allocator)
int | GetInt () const
unsigned | GetUint () const
int64_t | GetInt64 () const
uint64_t | GetUint64 () const
double | GetDouble () const
| Get the value as double type. More...
float | GetFloat () const
| Get the value as float type. More...
GenericValue & | SetInt (int i)
GenericValue & | SetUint (unsigned u)
GenericValue & | SetInt64 (int64_t i64)
GenericValue & | SetUint64 (uint64_t u64)
GenericValue & | SetDouble (double d)
GenericValue & | SetFloat (float f)
const Ch * | GetString () const
SizeType | GetStringLength () const
| Get the length of string. More...
GenericValue & | SetString (const Ch *s, SizeType length)
| Set this value as a string without copying source string. More...
GenericValue & | SetString (StringRefType s)
| Set this value as a string without copying source string. More...
GenericValue & | SetString (const Ch *s, SizeType length, Allocator &allocator)
| Set this value as a string by copying from source string. More...
GenericValue & | SetString (const Ch *s, Allocator &allocator)
| Set this value as a string by copying from source string. More...
GenericValue & | SetString (const std::basic_string< Ch > &s, Allocator &allocator)
| Set this value as a string by copying from source string. More...
GenericValue & | operator= (GenericValue &rhs) RAPIDJSON_NOEXCEPT
| Assignment with move semantics. More...
GenericValue & | operator= (StringRefType str) RAPIDJSON_NOEXCEPT
| Assignment of constant string reference (no copy) More...
template<typename T >
GenericValue & | operator= (T value)
| Assignment with primitive types. More...
template<typename SourceAllocator >
GenericValue & | CopyFrom (const GenericValue< Encoding, SourceAllocator > &rhs, Allocator &allocator)
| Deep-copy assignment from Value. More...
GenericValue & | Swap (GenericValue &other) RAPIDJSON_NOEXCEPT
| Exchange the contents of this value with those of other. More...
GenericValue & | Move () RAPIDJSON_NOEXCEPT
| Prepare Value for move semantics. More...
template<typename SourceAllocator >
bool | operator== (const GenericValue< Encoding, SourceAllocator > &rhs) const
| Equal-to operator. More...
bool | operator== (const Ch *rhs) const
| Equal-to operator with const C-string pointer.
bool | operator== (const std::basic_string< Ch > &rhs) const
| Equal-to operator with string object. More...
template<typename T >
bool | operator== (const T &rhs) const
| Equal-to operator with primitive types. More...
template<typename SourceAllocator >
bool | operator!= (const GenericValue< Encoding, SourceAllocator > &rhs) const
| Not-equal-to operator. More...
bool | operator!= (const Ch *rhs) const
| Not-equal-to operator with const C-string pointer.
template<typename T >
bool | operator!= (const T &rhs) const
| Not-equal-to operator with arbitrary types. More...
| GenericValue () RAPIDJSON_NOEXCEPT
| Default constructor creates a null value.
| GenericValue (Type type) RAPIDJSON_NOEXCEPT
| Constructor with JSON value type. More...
template<typename SourceAllocator >
| GenericValue (const GenericValue< Encoding, SourceAllocator > &rhs, Allocator &allocator)
| Explicit copy constructor (with allocator) More...
| GenericValue (bool b) RAPIDJSON_NOEXCEPT
| Constructor for boolean value. More...
| GenericValue (int i) RAPIDJSON_NOEXCEPT
| Constructor for int value.
| GenericValue (unsigned u) RAPIDJSON_NOEXCEPT
| Constructor for unsigned value.
| GenericValue (int64_t i64) RAPIDJSON_NOEXCEPT
| Constructor for int64_t value.
| GenericValue (uint64_t u64) RAPIDJSON_NOEXCEPT
| Constructor for uint64_t value.
| GenericValue (double d) RAPIDJSON_NOEXCEPT
| Constructor for double value.
| GenericValue (const Ch *s, SizeType length) RAPIDJSON_NOEXCEPT
| Constructor for constant string (i.e. do not make a copy of string)
| GenericValue (StringRefType s) RAPIDJSON_NOEXCEPT
| Constructor for constant string (i.e. do not make a copy of string)
| GenericValue (const Ch *s, SizeType length, Allocator &allocator)
| Constructor for copy-string (i.e. do make a copy of string)
| GenericValue (const Ch *s, Allocator &allocator)
| Constructor for copy-string (i.e. do make a copy of string)
| GenericValue (const std::basic_string< Ch > &s, Allocator &allocator)
| Constructor for copy-string from a string object (i.e. do make a copy of string) More...
| GenericValue (Array a) RAPIDJSON_NOEXCEPT
| Constructor for Array. More...
| GenericValue (Object o) RAPIDJSON_NOEXCEPT
| Constructor for Object. More...
| ~GenericValue ()
| Destructor. More...

## Friends

template<typename , typename >
class | GenericValue
void | swap (GenericDocument &a, GenericDocument &b) RAPIDJSON_NOEXCEPT
| free-standing swap function helper More...

## Detailed Description

### template<typename Encoding, typename Allocator = MemoryPoolAllocator<>, typename StackAllocator = CrtAllocator>
class rapidjson::GenericDocument< Encoding, Allocator, StackAllocator >

A document for parsing JSON text as DOM.

Note
  implements Handler concept

Template Parameters

  Encoding | Encoding for both parsing and string storage.
  Allocator | Allocator for allocating memory for the DOM
  StackAllocator | Allocator for allocating memory for stack during parsing.

Warning
  Although GenericDocument inherits from GenericValue, the API does not provide any virtual functions, especially no virtual destructor. To avoid memory leaks, do not `delete` a GenericDocument object via a pointer to a GenericValue.

## Constructor & Destructor Documentation

## GenericDocument() [1/2]

template<typename Encoding, typename Allocator = MemoryPoolAllocator<>, typename StackAllocator = CrtAllocator>

rapidjson::GenericDocument< Encoding, Allocator, StackAllocator >::GenericDocument | ( | Type | type,
|  | Allocator * | allocator = `0`,
|  | size_t | stackCapacity = `kDefaultStackCapacity`,
|  | StackAllocator * | stackAllocator = `0`
| ) |  |

inline explicit

Constructor.

Creates an empty document of specified type.

Parameters

  type | Mandatory type of object to create.
  allocator | Optional allocator for allocating memory.
  stackCapacity | Optional initial capacity of stack in bytes.
  stackAllocator | Optional allocator for allocating memory for stack.

## GenericDocument() [2/2]

template<typename Encoding, typename Allocator = MemoryPoolAllocator<>, typename StackAllocator = CrtAllocator>

rapidjson::GenericDocument< Encoding, Allocator, StackAllocator >::GenericDocument | ( | Allocator * | allocator = `0`,
|  | size_t | stackCapacity = `kDefaultStackCapacity`,
|  | StackAllocator * | stackAllocator = `0`
| ) |  |

inline

Constructor.

Creates an empty document which type is Null.

Parameters

  allocator | Optional allocator for allocating memory.
  stackCapacity | Optional initial capacity of stack in bytes.
  stackAllocator | Optional allocator for allocating memory for stack.

## Member Function Documentation

## operator ParseResult()

template<typename Encoding, typename Allocator = MemoryPoolAllocator<>, typename StackAllocator = CrtAllocator>

rapidjson::GenericDocument< Encoding, Allocator, StackAllocator >::operator ParseResult | ( |  | ) | const

inline

Implicit conversion to get the last parse result.

Returns
  ParseResult of the last parse operation

Document doc;
ParseResult ok = doc.Parse(json);
if (!ok)
printf( "JSON parse error: %s (%u)\n", GetParseError_En(ok.Code()), ok.Offset());

## Parse() [1/3]

template<typename Encoding, typename Allocator = MemoryPoolAllocator<>, typename StackAllocator = CrtAllocator>
template<unsigned parseFlags, typename SourceEncoding >

GenericDocument& rapidjson::GenericDocument< Encoding, Allocator, StackAllocator >::Parse | ( | const typename SourceEncoding::Ch * | str | ) |

inline

Parse JSON text from a read-only string (with Encoding conversion)

Template Parameters

  parseFlags | Combination of ParseFlag (must not contain kParseInsituFlag).
  SourceEncoding | Transcoding from input Encoding

Parameters

  str | Read-only zero-terminated string to be parsed.

## Parse() [2/3]

template<typename Encoding, typename Allocator = MemoryPoolAllocator<>, typename StackAllocator = CrtAllocator>
template<unsigned parseFlags>

GenericDocument& rapidjson::GenericDocument< Encoding, Allocator, StackAllocator >::Parse | ( | const Ch * | str | ) |

inline

Parse JSON text from a read-only string.

Template Parameters

  parseFlags | Combination of ParseFlag (must not contain kParseInsituFlag).

Parameters

  str | Read-only zero-terminated string to be parsed.

## Parse() [3/3]

template<typename Encoding, typename Allocator = MemoryPoolAllocator<>, typename StackAllocator = CrtAllocator>

GenericDocument& rapidjson::GenericDocument< Encoding, Allocator, StackAllocator >::Parse | ( | const Ch * | str | ) |

inline

Parse JSON text from a read-only string (with kParseDefaultFlags)

Parameters

  str | Read-only zero-terminated string to be parsed.

## ParseInsitu() [1/2]

template<typename Encoding, typename Allocator = MemoryPoolAllocator<>, typename StackAllocator = CrtAllocator>
template<unsigned parseFlags>

GenericDocument& rapidjson::GenericDocument< Encoding, Allocator, StackAllocator >::ParseInsitu | ( | Ch * | str | ) |

inline

Parse JSON text from a mutable string.

Template Parameters

  parseFlags | Combination of ParseFlag.

Parameters

  str | Mutable zero-terminated string to be parsed.

Returns
  The document itself for fluent API.

## ParseInsitu() [2/2]

template<typename Encoding, typename Allocator = MemoryPoolAllocator<>, typename StackAllocator = CrtAllocator>

GenericDocument& rapidjson::GenericDocument< Encoding, Allocator, StackAllocator >::ParseInsitu | ( | Ch * | str | ) |

inline

Parse JSON text from a mutable string (with kParseDefaultFlags)

Parameters

  str | Mutable zero-terminated string to be parsed.

Returns
  The document itself for fluent API.

## ParseStream() [1/3]

template<typename Encoding, typename Allocator = MemoryPoolAllocator<>, typename StackAllocator = CrtAllocator>
template<unsigned parseFlags, typename SourceEncoding , typename InputStream >

GenericDocument& rapidjson::GenericDocument< Encoding, Allocator, StackAllocator >::ParseStream | ( | InputStream & | is | ) |

inline

Parse JSON text from an input stream (with Encoding conversion)

Template Parameters

  parseFlags | Combination of ParseFlag.
  SourceEncoding | Encoding of input stream
  InputStream | Type of input stream, implementing Stream concept

Parameters

  is | Input stream to be parsed.

Returns
  The document itself for fluent API.

## ParseStream() [2/3]

template<typename Encoding, typename Allocator = MemoryPoolAllocator<>, typename StackAllocator = CrtAllocator>
template<unsigned parseFlags, typename InputStream >

GenericDocument& rapidjson::GenericDocument< Encoding, Allocator, StackAllocator >::ParseStream | ( | InputStream & | is | ) |

inline

Parse JSON text from an input stream.

Template Parameters

  parseFlags | Combination of ParseFlag.
  InputStream | Type of input stream, implementing Stream concept

Parameters

  is | Input stream to be parsed.

Returns
  The document itself for fluent API.

## ParseStream() [3/3]

template<typename Encoding, typename Allocator = MemoryPoolAllocator<>, typename StackAllocator = CrtAllocator>
template<typename InputStream >

GenericDocument& rapidjson::GenericDocument< Encoding, Allocator, StackAllocator >::ParseStream | ( | InputStream & | is | ) |

inline

Parse JSON text from an input stream (with kParseDefaultFlags)

Template Parameters

  InputStream | Type of input stream, implementing Stream concept

Parameters

  is | Input stream to be parsed.

Returns
  The document itself for fluent API.

## Populate()

template<typename Encoding, typename Allocator = MemoryPoolAllocator<>, typename StackAllocator = CrtAllocator>
template<typename Generator >

GenericDocument& rapidjson::GenericDocument< Encoding, Allocator, StackAllocator >::Populate | ( | Generator & | g | ) |

inline

Populate this document by a generator which produces SAX events.

Template Parameters

  Generator | A functor with `bool f(Handler)` prototype.

Parameters

  g | Generator functor which sends SAX events to the parameter.

Returns
  The document itself for fluent API.

## Swap()

template<typename Encoding, typename Allocator = MemoryPoolAllocator<>, typename StackAllocator = CrtAllocator>

GenericDocument& rapidjson::GenericDocument< Encoding, Allocator, StackAllocator >::Swap | ( | GenericDocument< Encoding, Allocator, StackAllocator > & | rhs | ) |

inline

Exchange the contents of this document with those of another.

Parameters

  rhs | Another document.

Note
  Constant complexity.

See also
  GenericValue::Swap

## Friends And Related Function Documentation

## swap

template<typename Encoding, typename Allocator = MemoryPoolAllocator<>, typename StackAllocator = CrtAllocator>

void swap | ( | GenericDocument< Encoding, Allocator, StackAllocator > & | a,
|  | GenericDocument< Encoding, Allocator, StackAllocator > & | b
| ) |  |

friend

free-standing swap function helper

Helper function to enable support for common swap implementation pattern based on `std::swap:`

void swap(MyClass& a, MyClass& b) {
using std::swap;
swap(a.doc, b.doc);
// ...
}

See also
  Swap()

The documentation for this class was generated from the following file:

- include/rapidjson/document.h